
\name{plot.Diffepoce}
\alias{plot.Diffepoce}

\title{Plot difference of EPOCE estimators between two joint frailty models.}

\description{
  Plots values of the difference of two Cross-Validated Prognosis Loss (CVPL) computed with two joint frailty models. Confidence intervals are allowed.
}

\usage{
  \method{plot}{Diffepoce}(x, conf.bands=TRUE, pos.legend="topright", cex.legend=0.7, ...)
}

\arguments{
  \item{x}{An object from the 'prediction' function, more generaly a \code{predFrailty} class object.}
  \item{conf.bands}{Logical value. Determines whether confidence intervals will be plotted. The default is FALSE.}
  \item{pos.legend}{The location of the legend can be specified by setting this argument to a single keyword from the list
                    '"bottomright"', '"bottom"', '"bottomleft"', '"left"', '"topleft"', '"top"', '"topright"', '"right"' and '"center"'. The default is '"topright"'.}
  \item{cex.legend}{size of the legend. Default is 0.7.}
  \item{\dots}{Other unused arguments.}
}

\value{
  Print one plot with one curve and its confidence interval.
}

\keyword{file}
